package com.blamejared.ctgui.api;

import com.blamejared.ctgui.client.gui.GuiMenu;
import net.minecraft.block.Block;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.*;
import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import org.apache.commons.lang3.tuple.Pair;
import org.lwjgl.opengl.GL11;

import java.awt.*;
import java.io.*;
import java.util.*;
import java.util.List;

public abstract class GuiBase extends GuiContainer {

    public SlotRecipe selectedSlot;
    public GuiTextField editingField;
    public GuiButton add;
    public GuiButton remove;
    protected ContainerBase container;
    protected GuiMenu menu = new GuiMenu();
    private boolean shouldOpenMenu;

    public GuiBase(ContainerBase container, int xSize, int ySize, boolean shouldOpenMenu) {
        super(container);
        this.container = container;
        this.field_146999_f = xSize;
        this.field_147000_g = ySize;
        this.shouldOpenMenu = shouldOpenMenu;
    }

    public static boolean isBlock(ItemStack stack) {
        ResourceLocation name = Block.field_149771_c.func_177774_c(Block.func_149634_a(stack.func_77973_b()));
        return !(name != null && name.toString().equals("minecraft:air")) && Block.field_149771_c.func_148741_d(name);
    }

    @Override
    public void func_73866_w_() {
        super.func_73866_w_();
        field_146292_n.clear();
        if(shouldOpenMenu)
            menu.open(this, field_147003_i - 102, field_147009_r + 2);
        editingField = new GuiTextField(2906, field_146289_q, field_147003_i - 104, field_147009_r - 26, field_146999_f + 102, 20);
        editingField.func_146203_f(Integer.MAX_VALUE);
        editingField.func_146184_c(true);
        add = new GuiButton(2906, getGuiLeft() + 86, getGuiTop() + 8, field_146289_q.func_78256_a("Add") + 4, 20, "Add");
        getButtonList().add(add);
        remove = new GuiButton(2907, getGuiLeft() + 86 + 2 + field_146289_q.func_78256_a("Add") + 4, getGuiTop() + 8, field_146289_q.func_78256_a("Remove") + 4, 20, "Remove");
        getButtonList().add(remove);

    }

    @Override
    public void func_73863_a(int mouseX, int mouseY, float partialTicks) {
        super.func_73863_a(mouseX, mouseY, partialTicks);
        editingField.func_146194_f();
    }

    @Override
    public void func_73876_c() {
        super.func_73876_c();
        if(selectedSlot != null) {
            if(!selectedSlot.func_75216_d()) {
                selectedSlot = null;
                editingField.func_146180_a("");
                if(shouldOpenMenu) {
                    menu.setState(false);
                    menu.toggle(false);
                    for(Pair<CheckButtonRecipe, Slider[]> but : menu.getButtons()) {
                        for(Slider slider : but.getValue()) {
                            slider.setValue(0);
                            slider.maxValue = 0;
                            slider.updateSlider();
                            field_146292_n.remove(slider);
                        }
                    }
                }
            } else {
                editingField.func_146180_a(selectedSlot.getItemString());
            }
        } else {
            editingField.func_146180_a("");
            if(shouldOpenMenu) {
                menu.setState(false);
                menu.toggle(false);
                for(Pair<CheckButtonRecipe, Slider[]> but : menu.getButtons()) {
                    for(Slider slider : but.getValue()) {
                        slider.setValue(0);
                        slider.maxValue = 0;
                        slider.updateSlider();
                        field_146292_n.remove(slider);
                    }
                }
            }

        }
        editingField.func_146178_a();
        final boolean[] canCreate = {true};
        container.getRecipeSlots().stream().filter(slot -> slot instanceof SlotRecipeOutput).filter(slot -> !slot.func_75216_d()).forEach(slot -> canCreate[0] = false);
        if(!canCreate[0]) {
            add.field_146124_l = false;
            remove.field_146124_l = false;
        } else {
            add.field_146124_l = true;
            remove.field_146124_l = true;
        }
        if(shouldOpenMenu) {
            if(selectedSlot != null) {
                if(selectedSlot.func_75216_d() && !selectedSlot.func_75211_c().func_77942_o()) {
                    menu.nbt.getLeft().field_146124_l = false;
                }
            }
        }
    }

    @Override
    protected void func_73864_a(int mouseX, int mouseY, int mouseButton) throws IOException {
        final boolean[] clickedSlot = new boolean[]{false};
        for(SlotRecipe slot : container.getRecipeSlots()) {
            Rectangle rectangle = new Rectangle(field_147003_i + slot.field_75223_e, field_147009_r + slot.field_75221_f, 18, 18);
            if(rectangle.contains(mouseX, mouseY)) {
                switch(mouseButton) {
                    case 0:
                        break;
                    case 1:
                        if(slot.func_75216_d()) {
                            clickedSlot[0] = true;
                            selectedSlot = slot;
                            editingField.func_146180_a(slot.getItemString());
                            if(shouldOpenMenu) {
                                menu.toggle(true);
                                for(Pair<CheckButtonRecipe, Slider[]> but : menu.getButtons()) {
                                    for(Slider slider : but.getValue()) {
                                        field_146292_n.remove(slider);
                                    }
                                }
                                menu.getFromMap(slot.getPropertyMap(), slot.getProperties());
                            }
                        }
                        break;
                    case 2:
                        clickedSlot[0] = true;
                        selectedSlot = null;
                        if(shouldOpenMenu) {
                            menu.toggle(false);
                            for(Pair<CheckButtonRecipe, Slider[]> but : menu.getButtons()) {
                                for(Slider slider : but.getValue()) {
                                    slider.updateSlider();
                                    field_146292_n.remove(slider);
                                }
                            }
                        }
                        if(editingField != null)
                            editingField.func_146180_a("");
                        break;
                }
            }

        }
        if(!clickedSlot[0]) {
            super.func_73864_a(mouseX, mouseY, mouseButton);
        }
    }

    public abstract String getOutputAdd();

    public abstract String getOutputRemove();

    protected void func_146284_a(GuiButton btn) {
        if(btn.equals(add)) {
            File scriptFile = new File(new File("scripts"), "/recipes.zs");
            if(!scriptFile.exists()) {
                generateFile(scriptFile);
            }
            try {
                List<String> lines = new LinkedList<>();
                BufferedReader reader = new BufferedReader(new FileReader(scriptFile));
                String line;
                while((line = reader.readLine()) != null) {
                    lines.add(line);
                }
                if(lines.isEmpty()) {
                    generateFile(scriptFile);
                    while((line = reader.readLine()) != null) {
                        lines.add(line);
                    }
                }
                reader.close();
                PrintWriter writer = new PrintWriter(new FileWriter(scriptFile));
                for(int i = 0; i < lines.size(); i++) {
                    String beforeLine = "";
                    if(i > 0)
                        beforeLine = lines.get(i - 1);

                    String lined = lines.get(i);
                    if(beforeLine.trim().equals("//#Add")) {
                        writer.println(getOutputAdd());
                    }
                    if(!lined.isEmpty()) {
                        writer.println(lined);
                    }

                }
                writer.close();
            } catch(IOException e) {
                e.printStackTrace();
            }
        }
        if(btn.equals(remove)) {
            File scriptFile = new File(new File("scripts"), "/recipes.zs");
            if(!scriptFile.exists()) {
                generateFile(scriptFile);
            }

            try {
                List<String> lines = new LinkedList<>();
                BufferedReader reader = new BufferedReader(new FileReader(scriptFile));
                String line;
                while((line = reader.readLine()) != null) {
                    lines.add(line);
                }
                if(lines.isEmpty()) {
                    generateFile(scriptFile);
                    while((line = reader.readLine()) != null) {
                        lines.add(line);
                    }
                }
                reader.close();
                PrintWriter writer = new PrintWriter(new FileWriter(scriptFile));
                for(int i = 0; i < lines.size(); i++) {
                    String beforeLine = "";
                    if(i > 0)
                        beforeLine = lines.get(i - 1);

                    String lined = lines.get(i);
                    if(beforeLine.trim().equals("//#Remove")) {
                        writer.println(getOutputRemove());
                    }
                    if(!lined.isEmpty()) {
                        writer.println(lined);
                    }
                }
                writer.close();
            } catch(IOException e) {
                e.printStackTrace();
            }
        }
    }

    public abstract ResourceLocation getTexture();

    protected void func_146976_a(float partialTicks, int mouseX, int mouseY) {
        GlStateManager.func_179123_a();
        GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
        Minecraft.func_71410_x().field_71446_o.func_110577_a(getTexture());
        func_73729_b(field_147003_i, field_147009_r, 0, 0, field_146999_f, field_147000_g);
        GlStateManager.func_179099_b();
        if(selectedSlot != null) {
            GlStateManager.func_179135_a(true, true, true, false);
            this.func_73733_a(field_147003_i + selectedSlot.field_75223_e, field_147009_r + selectedSlot.field_75221_f, field_147003_i + selectedSlot.field_75223_e + 16, field_147009_r + selectedSlot.field_75221_f + 16, Color.cyan.darker().getRGB(), Color.cyan.darker().getRGB());
            GlStateManager.func_179135_a(true, true, true, true);
        }
    }

    public List<GuiButton> getButtonList() {
        return this.field_146292_n;
    }

    public int getGuiLeft() {
        return field_147003_i;
    }

    public int getGuiTop() {
        return field_147009_r;
    }

    public int getXSize() {
        return field_146999_f;
    }

    public int getYSize() {
        return field_147000_g;
    }

    public GuiMenu getMenu() {
        return menu;
    }


    public void generateFile(File f) {
        try {
            f.createNewFile();
            PrintWriter writer = new PrintWriter(new FileWriter(f));
            writer.println("//This file was created via CT-GUI! Editing it is not advised!");
            writer.println("//Don't touch me!");
            writer.println("//#Remove");
            writer.println();
            writer.println("//Don't touch me!");
            writer.println("//#Add");
            writer.println();
            writer.println("//File End");
            writer.close();
        } catch(IOException e) {
            e.printStackTrace();
        }
    }

}
